
/*
  Copyright (C) 2002, 2008  Dmitry V. Levin <ldv@altlinux.org>

  CWD helper for packageof.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef	__CWD_H__
#define	__CWD_H__

#include <cstdlib>
#include <cerrno>
#include <error.h>
#include <fcntl.h>
#include <unistd.h>

class   CWD
{
	int     fd;

      public:
	CWD ()
	{
		fd = open (".", O_RDONLY | O_DIRECTORY);
	}

	~CWD ()
	{
		if (fd >= 0)
		{
			int     saved_errno = errno;

			if (fchdir (fd) < 0)
				error(EXIT_FAILURE, 0, "fchdir: %d", fd);
			close (fd);
			errno = saved_errno;
		}
	}
};

#endif	// __CWD_H__
